<p align="center">
   <img alt="houdini-asyncio" src="https://user-images.githubusercontent.com/32749673/64740929-d4435c00-d4ee-11e9-9b9f-f45236b8b61f.png">
</p>

#

<p align="center">
  <a href="https://discord.gg/UPnWKfh">
    <img
      alt="Solero Discord"
      src="https://img.shields.io/discord/323290581063172096?color=7289DA&label=discord"
    />
  </a>
  <a href="https://solero.me">
    <img
      alt="Solero Forum"
      src="https://img.shields.io/discourse/https/solero.me/topics?color=73afb6"
    />
  </a>
  <a href="https://github.com/Solero/houdini/issues">
    <img
      alt="Issue Tracker"
      src="https://img.shields.io/github/issues/solero/houdini-asyncio"
    />
  </a>
  <a href="./LICENSE">
    <img
      alt="License"
      src="https://img.shields.io/github/license/solero/houdini-asyncio"
    />
  </a>
  <a href="https://houdini.readthedocs.io/">
    <img
      alt="Documentation"
      src="https://readthedocs.org/projects/houdini/badge/?version=latest&style=flat"
    />
  </a>
</p>

<p align="center">A lightning-fast Club Penguin Private Server written in Python 3.</p>

- [Join our community](https://solero.me)
- [Documentation](https://houdini.readthedocs.io)

## Features :space_invader:

- :clock3: **Cross-era**: Different clients can play together on the same server.
- :exclamation: **Commands**: Built-in extensible commands API.
- :electric_plug: **Powerful Plugin API**: Easy and quick to write your own plugins.
- :speech_balloon: **Chat-filter**: Filter trolls with minimal configuration.
- :shield: **Permissions**: API to restrict access to server functionality & commands.

## Installation

Houdini can be run as a normal Python program under any operating system.

***NOTE**: Houdini requires Python 3.8.x to be installed*

```shell
$ git clone https://github.com/solero/houdini
$ cd houdini
$ pip install -r requirements.txt
$ python bootstrap.py login
```

## Installation with Docker

You can also use [Wand](https://github.com/solero/wand), a tool that installs Houdini, Dash and many other useful tools to compliment your experience.

This is especially useful for those who want a straightforward installation, where everything is installed for you!
Currently Wand only works on Linux servers. Windows and Mac servers could work but requires extra work!

## Game Screenshots

<img alt="Screenshot" width="700px" src="https://user-images.githubusercontent.com/32749673/64743472-05745a00-d4f8-11e9-9eed-f3565dc2e821.png">

<img alt="Screenshot" width="700px" src="https://user-images.githubusercontent.com/32749673/64743711-d8747700-d4f8-11e9-9bab-de08090db34d.png">

<img alt="Screenshot" width="700px" src="https://user-images.githubusercontent.com/32749673/64743891-854ef400-d4f9-11e9-8d78-9d73493eb04d.png">

## Contributing

:heartpulse: So glad to hear of your interest!

If you have suggestions for how this project can be improved, or want to report a bug, please feel free to open an issue! We welcome any and all contributions. We listen to all your questions and are always active on the [Solero Discord server](https://solero.me/discord).

## License

MIT Licensed
